import { useContext, createContext, useRef, useState, useCallback, useEffect } from 'react';
import { parsePath, createPath, createBrowserHistory, createHashHistory, createMemoryHistory } from 'history';
import { jsx, Fragment } from 'react/jsx-runtime';
import { match as match$1 } from 'path-to-regexp';

var i = 1;
function uniqId() {
  return i++;
}
function cancelPromise() {
  return new Promise(function () {});
}
function createCurrentGuard() {
  var current;
  return [function currentGuard(promise) {
    var cur = uniqId();
    current = cur;
    return promise.then(function (result) {
      return current === cur ? result : cancelPromise();
    }).catch(function (err) {
      return current === cur ? Promise.reject(err) : cancelPromise();
    });
  }, function cancel() {
    current = undefined;
  }];
}

function _slicedToArray$3(arr, i) { return _arrayWithHoles$3(arr) || _iterableToArrayLimit$3(arr, i) || _unsupportedIterableToArray$4(arr, i) || _nonIterableRest$3(); }

function _nonIterableRest$3() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray$4(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray$4(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray$4(o, minLen); }

function _arrayLikeToArray$4(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit$3(arr, i) { var _i = arr == null ? null : typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"]; if (_i == null) return; var _arr = []; var _n = true; var _d = false; var _s, _e; try { for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles$3(arr) { if (Array.isArray(arr)) return arr; }

function ownKeys$4(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) { symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); } keys.push.apply(keys, symbols); } return keys; }

function _objectSpread$4(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys$4(Object(source), true).forEach(function (key) { _defineProperty$4(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys$4(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty$4(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
var ViewContext = /*#__PURE__*/createContext(null);
function ViewProvider(props) {
  return /*#__PURE__*/jsx(ViewContext.Provider, _objectSpread$4({}, props));
}
function useView() {
  return useContext(ViewContext);
}
function View() {
  var view = useView();
  return /*#__PURE__*/jsx(Fragment, {
    children: view
  });
}
var DataContext = /*#__PURE__*/createContext([undefined, {}]);
function useDataContext() {
  return useContext(DataContext);
}
function useNamedData() {
  return useDataContext()[1];
}
function DataProvider(_ref) {
  var children = _ref.children,
      name = _ref.name,
      data = _ref.data;
  var namedData = useNamedData();
  return /*#__PURE__*/jsx(DataContext.Provider, {
    value: [data, name ? _objectSpread$4(_objectSpread$4({}, namedData), {}, _defineProperty$4({}, name, data)) : namedData],
    children: children
  });
}
function useData(name) {
  var _useDataContext = useDataContext(),
      _useDataContext2 = _slicedToArray$3(_useDataContext, 2),
      data = _useDataContext2[0],
      namedData = _useDataContext2[1];

  return name ? namedData[name] : data;
}

function _toConsumableArray$1(arr) { return _arrayWithoutHoles$1(arr) || _iterableToArray$1(arr) || _unsupportedIterableToArray$3(arr) || _nonIterableSpread$1(); }

function _nonIterableSpread$1() { throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray$3(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray$3(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray$3(o, minLen); }

function _iterableToArray$1(iter) { if (typeof Symbol !== "undefined" && iter[Symbol.iterator] != null || iter["@@iterator"] != null) return Array.from(iter); }

function _arrayWithoutHoles$1(arr) { if (Array.isArray(arr)) return _arrayLikeToArray$3(arr); }

function _arrayLikeToArray$3(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function ownKeys$3(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) { symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); } keys.push.apply(keys, symbols); } return keys; }

function _objectSpread$3(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys$3(Object(source), true).forEach(function (key) { _defineProperty$3(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys$3(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty$3(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function create(routes) {
  var options = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
  return {
    routes: Array.isArray(routes) ? routes : [routes],
    baseUrl: options.baseUrl || '',
    options: options
  };
}
function match(router, pathname) {
  function matchRoutes(routes, baseUrl, // eslint-disable-next-line @typescript-eslint/no-shadow
  pathname) {
    for (var i = 0; i < routes.length; i++) {
      var route = routes[i];
      var end = !route.children;
      var matched = route.path ? match$1(route.path, {
        strict: true,
        sensitive: true,
        decode: typeof decodeURIComponent === 'function' ? decodeURIComponent : undefined,
        end: end
      })(pathname) : {
        path: '',
        index: 0,
        params: {}
      };

      if (matched) {
        var result = _objectSpread$3({
          route: route
        }, matched);

        if (end) return [result];
        var children = matchRoutes(route.children, "".concat(baseUrl).concat(route.path || ''), pathname.slice(matched.path.length));
        if (children) return [result].concat(_toConsumableArray$1(children));
        return undefined;
      }
    }

    return undefined;
  }

  return matchRoutes(router.routes, router.baseUrl, pathname.slice(router.baseUrl.length));
}

function _slicedToArray$2(arr, i) { return _arrayWithHoles$2(arr) || _iterableToArrayLimit$2(arr, i) || _unsupportedIterableToArray$2(arr, i) || _nonIterableRest$2(); }

function _nonIterableRest$2() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray$2(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray$2(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray$2(o, minLen); }

function _arrayLikeToArray$2(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit$2(arr, i) { var _i = arr == null ? null : typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"]; if (_i == null) return; var _arr = []; var _n = true; var _d = false; var _s, _e; try { for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles$2(arr) { if (Array.isArray(arr)) return arr; }
function resolve(router, pathname, location) {
  var matched = match(router, pathname);
  if (!matched) return Promise.reject(new Error('Not Found'));
  return Promise.all(matched.map(function (_ref, index) {
    var _route$data;

    var params = _ref.params,
        route = _ref.route;
    var ctx = {
      matched: matched,
      index: index,
      router: router,
      pathname: pathname,
      location: location
    };

    function resolveComponent() {
      if (!route.component) return View;
      var r = route.component(params, ctx);
      return Promise.resolve(r).then(function (m) {
        return 'default' in m ? m.default : m;
      });
    }

    return Promise.all([(_route$data = route.data) === null || _route$data === void 0 ? void 0 : _route$data.call(route, params, ctx), resolveComponent()]).then(function (_ref2) {
      var _ref3 = _slicedToArray$2(_ref2, 2),
          data = _ref3[0],
          C = _ref3[1];

      return /*#__PURE__*/jsx(DataProvider, {
        data: data,
        name: route.name,
        children: /*#__PURE__*/jsx(C, {})
      });
    });
  })).then(function (views) {
    return views.reverse().reduce(function (acc, view) {
      return /*#__PURE__*/jsx(ViewProvider, {
        value: acc,
        children: view
      });
    });
  });
}

var _excluded$2 = ["pathname", "state"],
    _excluded2 = ["initialEntries", "initialIndex"];

function _objectWithoutProperties$2(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose$2(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose$2(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray$1(arr) || _nonIterableSpread(); }

function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _iterableToArray(iter) { if (typeof Symbol !== "undefined" && iter[Symbol.iterator] != null || iter["@@iterator"] != null) return Array.from(iter); }

function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) return _arrayLikeToArray$1(arr); }

function ownKeys$2(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) { symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); } keys.push.apply(keys, symbols); } return keys; }

function _objectSpread$2(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys$2(Object(source), true).forEach(function (key) { _defineProperty$2(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys$2(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty$2(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _slicedToArray$1(arr, i) { return _arrayWithHoles$1(arr) || _iterableToArrayLimit$1(arr, i) || _unsupportedIterableToArray$1(arr, i) || _nonIterableRest$1(); }

function _nonIterableRest$1() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray$1(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray$1(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray$1(o, minLen); }

function _arrayLikeToArray$1(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit$1(arr, i) { var _i = arr == null ? null : typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"]; if (_i == null) return; var _arr = []; var _n = true; var _d = false; var _s, _e; try { for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles$1(arr) { if (Array.isArray(arr)) return arr; }
var Context$1 = /*#__PURE__*/createContext(null);

var _createCurrentGuard = createCurrentGuard(),
    _createCurrentGuard2 = _slicedToArray$1(_createCurrentGuard, 2),
    currentGuard = _createCurrentGuard2[0],
    cancelAll = _createCurrentGuard2[1];

function BaseRouter(_ref) {
  var routes = _ref.routes,
      history = _ref.history,
      children = _ref.children,
      _ref$errorHandler = _ref.errorHandler,
      errorHandler = _ref$errorHandler === void 0 ? Promise.reject : _ref$errorHandler,
      baseUrl = _ref.baseUrl,
      _ref$resolve = _ref.resolve,
      resolve$1 = _ref$resolve === void 0 ? resolve : _ref$resolve;
  var routerRef = useRef();
  routerRef.current = create(routes, {
    baseUrl: baseUrl
  }); // TODO: 移到上层 context

  var _useState = useState(),
      _useState2 = _slicedToArray$1(_useState, 2),
      loading = _useState2[0],
      setLoading = _useState2[1];

  var _useState3 = useState(),
      _useState4 = _slicedToArray$1(_useState3, 2),
      view = _useState4[0],
      setView = _useState4[1];

  var viewStackRef = useRef([]);
  var locationStackRef = useRef([history.location]);
  var cancel = useCallback(function () {
    setLoading(function (l) {
      if (l && l.status === 'pending') {
        cancelAll();
        return undefined;
      }

      return l;
    });
  }, []);

  var rejectLoading = function rejectLoading(key) {
    return function (e) {
      setLoading({
        key: key,
        status: 'rejected'
      });
      throw e;
    };
  };

  var prefetch = useCallback(function (to) {
    var _ref2 = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {},
        state = _ref2.state,
        replace = _ref2.replace,
        done = _ref2.done,
        onError = _ref2.onError;

    var router = routerRef.current;
    to = router.baseUrl + to;

    var location = _objectSpread$2(_objectSpread$2({
      pathname: '',
      search: '',
      hash: ''
    }, parsePath(to)), {}, {
      state: state
    });

    var resolvePromise = resolve$1(router, location.pathname, location).catch(errorHandler);
    resolvePromise.then(done, onError);
    return function commit() {
      var _history$location$sta;

      var nextIndex = (((_history$location$sta = history.location.state) === null || _history$location$sta === void 0 ? void 0 : _history$location$sta.index) || 0) + (replace ? 0 : 1);
      var key = uniqId();
      setLoading({
        key: key,
        status: 'pending'
      });
      currentGuard(resolvePromise).then(function (resolvedView) {
        locationStackRef.current = [].concat(_toConsumableArray(locationStackRef.current.slice(0, nextIndex)), [location]);
        viewStackRef.current = [].concat(_toConsumableArray(viewStackRef.current.slice(0, nextIndex)), [resolvedView]);
        history[replace ? 'replace' : 'push'](to, {
          index: nextIndex,
          locationStack: locationStackRef.current
        });
        setLoading({
          key: key,
          status: 'resolved'
        });
      }).catch(rejectLoading(key));
    };
  }, []);
  var navigate = useCallback(function (to, options) {
    prefetch(to, options)();
  }, []);
  var refresh = useCallback(function () {
    var router = routerRef.current;

    var _history$location = history.location,
        pathname = _history$location.pathname,
        state = _history$location.state,
        restLocation = _objectWithoutProperties$2(_history$location, _excluded$2);

    return navigate(createPath(_objectSpread$2(_objectSpread$2({}, restLocation), {}, {
      pathname: pathname.slice(router.baseUrl.length)
    })), {
      replace: true,
      state: locationStackRef.current[state.index].state
    });
  }, [navigate]);
  var go = useCallback(function (delta) {
    history.go(delta);
  }, []);
  var back = useCallback(function () {
    history.back();
  }, []);
  var forward = useCallback(function () {
    history.forward();
  }, []);
  var createHref = useCallback(function (to) {
    return routerRef.current.baseUrl + history.createHref(to);
  }, []);
  useEffect(function () {
    var _history$location$sta2;

    var router = routerRef.current;
    var locationStack = ((_history$location$sta2 = history.location.state) === null || _history$location$sta2 === void 0 ? void 0 : _history$location$sta2.locationStack) || locationStackRef.current;
    locationStackRef.current = locationStack;
    var key = uniqId();
    setLoading({
      key: key,
      status: 'pending'
    });
    Promise.all(locationStack.map(function (l) {
      return resolve$1(router, createPath(l), l).catch(errorHandler);
    })).then(function (views) {
      viewStackRef.current = views;
      history.replace(createPath(history.location), history.location.state);
      setLoading({
        key: key,
        status: 'resolved'
      });
    }).catch(rejectLoading(key));
    return cancel;
  }, []);
  useEffect(function () {
    return history.listen(function (_ref3) {
      var _location$state;

      var action = _ref3.action,
          location = _ref3.location;
      cancel();
      var index = ((_location$state = location.state) === null || _location$state === void 0 ? void 0 : _location$state.index) || 0;
      setView(viewStackRef.current[index]);

      if (action === 'POP') {
        history.replace(createPath(history.location), _objectSpread$2(_objectSpread$2({}, history.location.state), {}, {
          locationStack: locationStackRef.current
        }));
      }
    });
  }, [history]);
  return /*#__PURE__*/jsx(Context$1.Provider, {
    value: {
      go: go,
      back: back,
      forward: forward,
      createHref: createHref,
      loading: loading,
      setLoading: setLoading,
      setView: setView,
      prefetch: prefetch,
      navigate: navigate,
      refresh: refresh,
      cancel: cancel
    },
    children: typeof children === 'undefined' ? view : /*#__PURE__*/jsx(ViewProvider, {
      value: view,
      children: children
    })
  });
}

function RouterComponent(props) {
  var history = createBrowserHistory();
  return /*#__PURE__*/jsx(BaseRouter, _objectSpread$2(_objectSpread$2({}, props), {}, {
    history: history
  }));
}
function HashRouter(props) {
  var history = createHashHistory();
  return /*#__PURE__*/jsx(BaseRouter, _objectSpread$2(_objectSpread$2({}, props), {}, {
    history: history
  }));
}
function MemoryRouter(_ref4) {
  var initialEntries = _ref4.initialEntries,
      initialIndex = _ref4.initialIndex,
      props = _objectWithoutProperties$2(_ref4, _excluded2);

  var history = createMemoryHistory({
    initialEntries: initialEntries,
    initialIndex: initialIndex
  });
  return /*#__PURE__*/jsx(BaseRouter, _objectSpread$2(_objectSpread$2({}, props), {}, {
    history: history
  }));
}
function useRouter() {
  return useContext(Context$1);
}
function useLoading() {
  return useContext(Context$1).loading;
}

var _excluded$1 = ["to"];

function ownKeys$1(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) { symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); } keys.push.apply(keys, symbols); } return keys; }

function _objectSpread$1(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys$1(Object(source), true).forEach(function (key) { _defineProperty$1(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys$1(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty$1(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _objectWithoutProperties$1(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose$1(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose$1(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }
function Link(_ref) {
  var to = _ref.to,
      rest = _objectWithoutProperties$1(_ref, _excluded$1);

  var _useRouter = useRouter(),
      navigate = _useRouter.navigate,
      createHref = _useRouter.createHref;

  function handleClick(e) {
    e.preventDefault();
    navigate(to);
  }

  return (
    /*#__PURE__*/
    // eslint-disable-next-line jsx-a11y/anchor-has-content
    jsx("a", _objectSpread$1(_objectSpread$1({}, rest), {}, {
      href: createHref(to),
      onClick: handleClick
    }))
  );
}

var _excluded = ["to", "children"];

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) { symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); } keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { var _i = arr == null ? null : typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"]; if (_i == null) return; var _arr = []; var _n = true; var _d = false; var _s, _e; try { for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }
var Context = /*#__PURE__*/createContext({
  loading: false
});
function usePrefetch() {
  return useContext(Context);
}
function PrefetchLink(_ref) {
  var to = _ref.to,
      children = _ref.children,
      rest = _objectWithoutProperties(_ref, _excluded);

  var _useRouter = useRouter(),
      prefetch = _useRouter.prefetch,
      createHref = _useRouter.createHref;

  var commitRef = useRef();

  var _useState = useState(false),
      _useState2 = _slicedToArray(_useState, 2),
      loading = _useState2[0],
      setLoading = _useState2[1];

  var _useState3 = useState(),
      _useState4 = _slicedToArray(_useState3, 2),
      error = _useState4[0],
      setError = _useState4[1];

  var _useState5 = useState(),
      _useState6 = _slicedToArray(_useState5, 2),
      view = _useState6[0],
      setView = _useState6[1];

  function prefetchIt() {
    setLoading(true);
    var commit = prefetch(to, {
      done: function done(v) {
        if (commit !== commitRef.current) return;
        setLoading(false);
        setView(v);
      },
      onError: function onError(e) {
        if (commit !== commitRef.current) return;
        setLoading(false);
        setError(e);
      }
    });
    commitRef.current = commit;
  }

  function handlePrefetch() {
    if (commitRef.current) return;
    prefetchIt();
  }

  function handleClick(e) {
    e.preventDefault();

    if (!commitRef.current) {
      prefetchIt();
    }

    commitRef.current();
  }

  useEffect(function () {
    commitRef.current = undefined;
  }, [to]);
  return /*#__PURE__*/jsx(Context.Provider, {
    value: {
      loading: loading,
      error: error,
      view: view
    },
    children: /*#__PURE__*/jsx("a", _objectSpread(_objectSpread({}, rest), {}, {
      href: createHref(to),
      onMouseEnter: handlePrefetch,
      onClick: handleClick,
      children: children
    }))
  });
}

export { BaseRouter, DataProvider, HashRouter, Link, MemoryRouter, PrefetchLink, RouterComponent as Router, View, ViewProvider, resolve as defaultResolve, useData, useDataContext, useLoading, useNamedData, usePrefetch, useRouter, useView };
//# sourceMappingURL=native-router-react.es.js.map
