import { Component, FC } from 'react';
import type { Location } from './types';
import { Matched, Route as BaseRoute, Router } from './router';
export declare type Context<T> = {
    matched: Matched<T>[];
    index: number;
    router: Router<BaseRoute>;
    pathname: string;
    location: Location;
};
declare type ReactComponent = Component | FC;
export declare type Route = BaseRoute<{
    name?: string;
    data?(params: any, ctx: Context<Route>): any | Promise<any>;
    component?(params: any, ctx: Context<Route>): ReactComponent | Promise<ReactComponent | {
        default: ReactComponent;
    }>;
}>;
export declare function resolve(router: Router<Route>, pathname: string, location: Location): Promise<JSX.Element>;
export {};
